/* MCVE v3.x C API
   (c) 2002 by Main Street Softworks, Inc.
   Written by Brad House

   This API is being released to the public domain to be modified and used in any manor the holder of this code sees fit.
   For any questions please contact  support@mainstreetsoftworks.com
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "libmcve_main.h"
#include "mcve.h"


// Standard includes ... all platforms
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <errno.h>
#include <fcntl.h>

//Win32 includes
#ifdef WIN32
#include <io.h>
#include <winsock2.h>
#include <sys/timeb.h>
#else // !Win32
// UNIX/POSIX includes
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <dirent.h>
#ifdef MCVE_PTHREAD
#include <pthread.h>
#endif // MCVE_PTHREAD

#endif //Win32

//SSL includes
#ifdef ENABLE_SSL
#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/rand.h>
#endif
#include "libmcve_misc.h"
#include "libmcve_parsing.h"
#include "libmcve_locking.h"


long MCVE_Count_CD_Lines(MCVE_CONN *myconn, long identifier)
{
  _MCVE_CONN *conn=(_MCVE_CONN *)myconn[0];
  char *temp, *str;
  long cnt=0;

  if (conn->queue[identifier].response == NULL) return(0);
  str=conn->queue[identifier].response;
  while (1) {
    temp=strstr(str, "\r\n");
    if (temp == NULL) break;
    cnt++;
    str=temp+2;
  }
  return(cnt);
}

char *MCVE_Get_CD_Line(char *string)
{
  char *temp;
  int len;
  if (string == NULL) return(NULL);
  temp=strstr(string, "\r\n");
  if (temp == NULL) return(NULL);
  len=strlen(string)-strlen(temp);
  return(MCVE_midstr(string, 0, len));
}

int MCVE_Count_CD_Columns(MCVE_CONN *myconn, long identifier)
{
  _MCVE_CONN *conn=(_MCVE_CONN *)myconn[0];
  char *temp;
  char *line, *str;
  int cnt=1;

  line=MCVE_Get_CD_Line(conn->queue[identifier].response);
  if (line == NULL) return(0);
  str=line;
  while (1) {
    temp=strchr(str, ',');
    if (temp == NULL) break;
    str=temp+1;
    cnt++;
  }
  free(line);
  return(cnt);
}

